[![jest](https://jestjs.io/img/jest-badge.svg)](https://github.com/facebook/jest) 
[![code style: prettier](https://img.shields.io/badge/code_style-prettier-ff69b4.svg?style=flat-square)](https://github.com/prettier/prettier) 
[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](https://github.com/davidnguyen179/web-extension-boilerplate/pulls)
![ci/cd](https://github.com/davidnguyen179/web-extension-boilerplate/workflows/ci/cd/badge.svg)

# ![img](https://gitlab.com/uploads/-/system/project/avatar/16473487/logo-min.png) Fedishare

Share the current tab on the [fediverse](https://fediverse.party/).

## Get the extension

### Gecko

| Firefox Add-ons | Trisquel Add-ons |
---|---
[![img](https://upload.wikimedia.org/wikipedia/commons/thumb/a/a0/Firefox_logo%2C_2019.svg/77px-Firefox_logo%2C_2019.svg.png)](https://addons.mozilla.org/en-US/firefox/addon/fedishare-addon) | [![img](https://trisquel.info/files/avatars/picture-1.png)](https://trisquel.info/en/browser/addons/fedishare)

### Blink (In process)

| Chrome Web Store | Opera addons |
---|---
![img](https://storage.googleapis.com/chrome-gcs-uploader.appspot.com/image/WlD8wC6g8khYWPJUsQceQkhXSlv1/tbyBjqi7Zu733AAKA5n4.png) | ![img](https://addons-static.operacdn.com/static/header-footer/css/img/opera-addons.png)

## Features

Simplest add-on for the fediverse. Share web pages right from the toolbar button.

### Supported services/protocols:

- Diaspora
- Friendica
- Gnusocial
- Hubzilla / Zap
- Lemmy
- Mastodon / Misskey
- Pleroma
- Socialhome
- XMPP

## Contributing

You can contribute in the following ways:

-   Finding and reporting bugs.
-   Contributing code to the project by fixing bugs or implementing features.


### Bug reports

Bug reports and feature suggestions can be submitted to [Gitlab Issues](https://gitlab.com/mickie1/share-freedom-extension/issues). Please make sure that you are not submitting duplicates, and that a similar report or request has not already been resolved or rejected in the past using the search function. Please also use descriptive, concise titles.


### Pull request

Please use clean, concise titles for your pull requests.

## Build

This project uses the [Web Extension Boilerplate](https://github.com/davidnguyen179/web-extension-boilerplate).

### Prerequisites

Gecko
- Mozilla Firefox 59 (or higher) 

**Install all dependencies:** `npm i`

### Development

##### Chrome

- Dev: `npm run app:chrome-dev`
- Production: `npm run app:chrome`

##### Edge

- Dev: `npm run app:edge-dev`
- Production: `npm run app:edge`

##### Firefox

- Dev: `npm run app:firefox-dev`
- Production: `npm run app:firefox`

#### Load package to browsers

1. Go to the browser's URL address bar

In Chrome:
2. Enter `chrome://extensions`

In Edge:
2. Enter `edge://extensions`

In Firefox:
2. Enter `about:debugging#/runtime/this-firefox`

In Chrome and Edge: 
   3. Turn on "**Developer mode**"
   4. Load extension by clicking "**Load unpacked**"
   5. Browse to `dist/` in source code. 

In Firefox:
   3. Click **Load Temporary Add-on...** 
   4. Browse to your `manifest.json` & click **Open**

#### CSS

[tailwindcss](https://tailwindcss.com) is the framework used for this project.

- Dev: `npm run style-dev`
- Production: `npm run style`

Set all css custom in: `public/styles.css`. The `main.css` is generated in `dist`.

## Donations

If you like the stuff I make and are financially able please consider donating. Your support allows me to dedicate more time to the projects I'm working on.

<a href='https://ko-fi.com/mugcake' target='_blank'><img height='35' style='border:0px;height:46px;' src='https://uploads-ssl.webflow.com/5c14e387dab576fe667689cf/5cbed8a433a3f45a772abaf5_SupportMe_blue-p-500.png' border='0' alt='Buy Me a Coffee at ko-fi.com' />

[![img](https://liberapay.com/assets/widgets/donate.svg)](https://liberapay.com/mickie/)

__Bitcoin BTC:__ bc1qf7v8zty2yz8phulet29wcpxjclvffn5w6ry43w

__Ethereum ETH:__ 0xca2FD9C3834694E2cB3db3bf79b3AfB083bA6732

## License

[![Large GPLv3 logo with “Free as in Freedom”](https://www.gnu.org/graphics/gplv3-with-text-136x68.png)](http://www.gnu.org/licenses/gpl-3.0.en.html)

    Copyright (C) 2019-2021 Miguel (aka mickie) <millet@tuta.io>
    This file is part of Fedishare.
    Fedishare is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


